Statistics
| Branch: | Revision:

root / common.sh.in @ 6738cd80

History | View | Annotate | Download (8.7 kB)

1 79224631 Lance Albertson
#
2 79224631 Lance Albertson
3 79224631 Lance Albertson
# Copyright (C) 2007, 2008, 2009 Google Inc.
4 79224631 Lance Albertson
#
5 79224631 Lance Albertson
# This program is free software; you can redistribute it and/or modify
6 79224631 Lance Albertson
# it under the terms of the GNU General Public License as published by
7 79224631 Lance Albertson
# the Free Software Foundation; either version 2 of the License, or
8 79224631 Lance Albertson
# (at your option) any later version.
9 79224631 Lance Albertson
#
10 79224631 Lance Albertson
# This program is distributed in the hope that it will be useful, but
11 79224631 Lance Albertson
# WITHOUT ANY WARRANTY; without even the implied warranty of
12 79224631 Lance Albertson
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
13 79224631 Lance Albertson
# General Public License for more details.
14 79224631 Lance Albertson
#
15 79224631 Lance Albertson
# You should have received a copy of the GNU General Public License
16 79224631 Lance Albertson
# along with this program; if not, write to the Free Software
17 79224631 Lance Albertson
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
18 79224631 Lance Albertson
# 02110-1301, USA.
19 79224631 Lance Albertson
20 8d0132dc Lance Albertson
AWK="@AWK@"
21 8d0132dc Lance Albertson
DUMP="@DUMP@"
22 8d0132dc Lance Albertson
LOSETUP="@LOSETUP@"
23 8d0132dc Lance Albertson
KPARTX="@KPARTX@"
24 8d0132dc Lance Albertson
SFDISK="@SFDISK@"
25 ab712029 Lance Albertson
QEMU_IMG="@QEMU_IMG@"
26 8d0132dc Lance Albertson
MKDIR_P="@MKDIR_P@"
27 47c86659 Nikos Skalkotos
XMLSTARLET="@XMLSTARLET@"
28 47c86659 Nikos Skalkotos
29 47c86659 Nikos Skalkotos
@WINSUPPORT_TRUE@windows_support="yes"
30 8d0132dc Lance Albertson
31 79224631 Lance Albertson
CLEANUP=( )
32 79224631 Lance Albertson
33 79224631 Lance Albertson
log_error() {
34 79224631 Lance Albertson
  echo "$@" >&2
35 79224631 Lance Albertson
}
36 79224631 Lance Albertson
37 e7a2d1ad Lance Albertson
debug() {
38 9014a39d Lance Albertson
    [ "$IMAGE_DEBUG" == "1" -o "$IMAGE_DEBUG" == "yes" ] &&  $@ || :
39 e7a2d1ad Lance Albertson
}
40 e7a2d1ad Lance Albertson
41 79224631 Lance Albertson
get_api5_arguments() {
42 79224631 Lance Albertson
  GETOPT_RESULT=$*
43 79224631 Lance Albertson
  # Note the quotes around `$TEMP': they are essential!
44 79224631 Lance Albertson
  eval set -- "$GETOPT_RESULT"
45 79224631 Lance Albertson
  while true; do
46 79224631 Lance Albertson
    case "$1" in
47 79224631 Lance Albertson
      -i|-n) instance=$2; shift 2;;
48 79224631 Lance Albertson
49 79224631 Lance Albertson
      -o) old_name=$2; shift 2;;
50 79224631 Lance Albertson
51 79224631 Lance Albertson
      -b) blockdev=$2; shift 2;;
52 79224631 Lance Albertson
53 79224631 Lance Albertson
      -s) swapdev=$2; shift 2;;
54 79224631 Lance Albertson
55 79224631 Lance Albertson
      --) shift; break;;
56 79224631 Lance Albertson
57 79224631 Lance Albertson
      *)  log_error "Internal error!" >&2; exit 1;;
58 79224631 Lance Albertson
    esac
59 79224631 Lance Albertson
  done
60 79224631 Lance Albertson
  if [ -z "$instance" -o -z "$blockdev" ]; then
61 79224631 Lance Albertson
    log_error "Missing OS API Argument (-i, -n, or -b)"
62 79224631 Lance Albertson
    exit 1
63 79224631 Lance Albertson
  fi
64 79224631 Lance Albertson
  if [ "$SCRIPT_NAME" != "export" -a -z "$swapdev"  ]; then
65 79224631 Lance Albertson
    log_error "Missing OS API Argument -s (swapdev)"
66 79224631 Lance Albertson
    exit 1
67 79224631 Lance Albertson
  fi
68 79224631 Lance Albertson
  if [ "$SCRIPT_NAME" = "rename" -a -z "$old_name"  ]; then
69 79224631 Lance Albertson
    log_error "Missing OS API Argument -o (old_name)"
70 79224631 Lance Albertson
    exit 1
71 79224631 Lance Albertson
  fi
72 79224631 Lance Albertson
}
73 79224631 Lance Albertson
74 79224631 Lance Albertson
get_api10_arguments() {
75 79224631 Lance Albertson
  if [ -z "$INSTANCE_NAME" -o -z "$HYPERVISOR" -o -z "$DISK_COUNT" ]; then
76 79224631 Lance Albertson
    log_error "Missing OS API Variable:"
77 79224631 Lance Albertson
    log_error "(INSTANCE_NAME HYPERVISOR or DISK_COUNT)"
78 79224631 Lance Albertson
    exit 1
79 79224631 Lance Albertson
  fi
80 79224631 Lance Albertson
  instance=$INSTANCE_NAME
81 79224631 Lance Albertson
  if [ $DISK_COUNT -lt 1 -o -z "$DISK_0_PATH" ]; then
82 79224631 Lance Albertson
    log_error "At least one disk is needed"
83 79224631 Lance Albertson
    exit 1
84 79224631 Lance Albertson
  fi
85 79224631 Lance Albertson
  if [ "$SCRIPT_NAME" = "export" ]; then
86 79224631 Lance Albertson
    if [ -z "$EXPORT_DEVICE" ]; then
87 79224631 Lance Albertson
      log_error "Missing OS API Variable EXPORT_DEVICE"
88 79224631 Lance Albertson
    fi
89 79224631 Lance Albertson
    blockdev=$EXPORT_DEVICE
90 79224631 Lance Albertson
  elif [ "$SCRIPT_NAME" = "import" ]; then
91 79224631 Lance Albertson
    if [ -z "$IMPORT_DEVICE" ]; then
92 79224631 Lance Albertson
       log_error "Missing OS API Variable IMPORT_DEVICE"
93 79224631 Lance Albertson
    fi
94 79224631 Lance Albertson
    blockdev=$IMPORT_DEVICE
95 79224631 Lance Albertson
  else
96 79224631 Lance Albertson
    blockdev=$DISK_0_PATH
97 79224631 Lance Albertson
  fi
98 79224631 Lance Albertson
  if [ "$SCRIPT_NAME" = "rename" -a -z "$OLD_INSTANCE_NAME" ]; then
99 79224631 Lance Albertson
    log_error "Missing OS API Variable OLD_INSTANCE_NAME"
100 79224631 Lance Albertson
  fi
101 79224631 Lance Albertson
  old_name=$OLD_INSTANCE_NAME
102 79224631 Lance Albertson
}
103 79224631 Lance Albertson
104 ab462591 Constantinos Venetsanopoulos
get_api20_parameters() {
105 8e5449f1 Constantinos Venetsanopoulos
  if [ -z "$OSP_IMG_ID" -o -z "$OSP_IMG_FORMAT" -o -z "$OSP_IMG_PASSWD" ]; then
106 ab462591 Constantinos Venetsanopoulos
    log_error "Missing OS API Parameter:"
107 8e5449f1 Constantinos Venetsanopoulos
    log_error "(OSP_IMG_ID or OSP_IMG_FORMAT or OSP_IMG_PASSWD)"
108 ab462591 Constantinos Venetsanopoulos
    exit 1
109 ab462591 Constantinos Venetsanopoulos
  fi
110 ab462591 Constantinos Venetsanopoulos
  IMG_ID=$OSP_IMG_ID
111 8e5449f1 Constantinos Venetsanopoulos
  IMG_FORMAT=$OSP_IMG_FORMAT
112 ab462591 Constantinos Venetsanopoulos
  IMG_PASSWD=$OSP_IMG_PASSWD
113 ab462591 Constantinos Venetsanopoulos
}
114 ab462591 Constantinos Venetsanopoulos
115 b05b1ab6 Lance Albertson
mount_disk0() {
116 77449e7c Lance Albertson
    local target=$1
117 3173a4bc Lance Albertson
    mount $root_dev $target
118 3173a4bc Lance Albertson
    CLEANUP+=("umount $target")
119 77449e7c Lance Albertson
    if [ -n "${boot_dev}" ] ; then
120 77449e7c Lance Albertson
        $MKDIR_P $target/boot
121 77449e7c Lance Albertson
        mount $boot_dev $target/boot
122 77449e7c Lance Albertson
        CLEANUP+=("umount $target/boot")
123 77449e7c Lance Albertson
    fi
124 1c571a34 Lance Albertson
    # sync the file systems before unmounting to ensure everything is flushed
125 1c571a34 Lance Albertson
    # out
126 1c571a34 Lance Albertson
    CLEANUP+=("sync")
127 b05b1ab6 Lance Albertson
}
128 b05b1ab6 Lance Albertson
129 79224631 Lance Albertson
map_disk0() {
130 77449e7c Lance Albertson
    blockdev="$1"
131 77449e7c Lance Albertson
    filesystem_dev_base=`$KPARTX -l -p- $blockdev | \
132 77449e7c Lance Albertson
                            grep -m 1 -- "-1.*$blockdev" | \
133 77449e7c Lance Albertson
                            $AWK '{print $1}'`
134 77449e7c Lance Albertson
    if [ -z "$filesystem_dev_base" ]; then
135 77449e7c Lance Albertson
        log_error "Cannot interpret kpartx output and get partition mapping"
136 77449e7c Lance Albertson
        exit 1
137 77449e7c Lance Albertson
    fi
138 77449e7c Lance Albertson
    $KPARTX -a -p- $blockdev > /dev/null
139 77449e7c Lance Albertson
    filesystem_dev="/dev/mapper/${filesystem_dev_base/%-1/}"
140 77449e7c Lance Albertson
    if [ ! -b "/dev/mapper/$filesystem_dev_base" ]; then
141 77449e7c Lance Albertson
        log_error "Can't find kpartx mapped partition: /dev/mapper/$filesystem_dev_base"
142 77449e7c Lance Albertson
        exit 1
143 77449e7c Lance Albertson
    fi
144 494927a8 Lance Albertson
    echo "$filesystem_dev"
145 494927a8 Lance Albertson
}
146 494927a8 Lance Albertson
147 494927a8 Lance Albertson
map_partition() {
148 494927a8 Lance Albertson
    filesystem_dev="$1"
149 494927a8 Lance Albertson
    partition="$2"
150 6738cd80 Nikos Skalkotos
    if [ "${SWAP}" = "yes" -a "${BOOT}" = "yes" ] ; then
151 494927a8 Lance Albertson
        boot_dev="${filesystem_dev}-1"
152 494927a8 Lance Albertson
        swap_dev="${filesystem_dev}-2"
153 494927a8 Lance Albertson
        root_dev="${filesystem_dev}-3"
154 6738cd80 Nikos Skalkotos
    elif [ "${SWAP}" = "no" -a "${BOOT}" = "yes" ] ; then
155 494927a8 Lance Albertson
        boot_dev="${filesystem_dev}-1"
156 494927a8 Lance Albertson
        root_dev="${filesystem_dev}-2"
157 6738cd80 Nikos Skalkotos
    elif [ "${SWAP}" = "yes" -a "${BOOT}" = "no" ] ; then
158 494927a8 Lance Albertson
        swap_dev="${filesystem_dev}-1"
159 494927a8 Lance Albertson
        root_dev="${filesystem_dev}-2"
160 6738cd80 Nikos Skalkotos
    elif [ "${SWAP}" = "no" -a "${BOOT}" = "no" ] ; then
161 494927a8 Lance Albertson
        root_dev="${filesystem_dev}-1"
162 77449e7c Lance Albertson
    fi
163 494927a8 Lance Albertson
    echo "$(eval "echo \${$(echo ${partition}_dev)"})"
164 79224631 Lance Albertson
}
165 79224631 Lance Albertson
166 79224631 Lance Albertson
unmap_disk0() {
167 8d0132dc Lance Albertson
  $KPARTX -d -p- $1
168 79224631 Lance Albertson
}
169 79224631 Lance Albertson
170 79224631 Lance Albertson
cleanup() {
171 31f11819 Nikos Skalkotos
  # if something fails here, it souldn't call cleanup again...
172 31f11819 Nikos Skalkotos
  trap - EXIT
173 31f11819 Nikos Skalkotos
174 79224631 Lance Albertson
  if [ ${#CLEANUP[*]} -gt 0 ]; then
175 79224631 Lance Albertson
    LAST_ELEMENT=$((${#CLEANUP[*]}-1))
176 79224631 Lance Albertson
    REVERSE_INDEXES=$(seq ${LAST_ELEMENT} -1 0)
177 79224631 Lance Albertson
    for i in $REVERSE_INDEXES; do
178 31f11819 Nikos Skalkotos
        # If something fails here, it's better to retry it for a few times
179 31f11819 Nikos Skalkotos
        # before we give up with an error. This is needed for kpartx when
180 31f11819 Nikos Skalkotos
        # dealing with ntfs partitions mounted through fuse. umount is not
181 31f11819 Nikos Skalkotos
        # synchronous and may return while the partition is still busy. A
182 31f11819 Nikos Skalkotos
        # premature attempt to delete partition mappings through kpartx on a
183 31f11819 Nikos Skalkotos
        # device that hosts previously mounted ntfs partition may fail with an 
184 31f11819 Nikos Skalkotos
        # `device-mapper: remove ioctl failed: Device or resource busy'
185 31f11819 Nikos Skalkotos
        # error. A sensible workaround for this is to wait for a while and then
186 31f11819 Nikos Skalkotos
        # try again.
187 31f11819 Nikos Skalkotos
        local cmd=${CLEANUP[$i]}
188 31f11819 Nikos Skalkotos
        $cmd || for interval in 0.25 0.5 1 2 4; do
189 31f11819 Nikos Skalkotos
            echo "Command $cmd failed!"
190 31f11819 Nikos Skalkotos
            echo "I'll wait for $interval secs and will retry..."
191 31f11819 Nikos Skalkotos
            sleep $interval
192 31f11819 Nikos Skalkotos
            $cmd && break
193 31f11819 Nikos Skalkotos
        done
194 31f11819 Nikos Skalkotos
        test $? -eq 1 && { echo "Giving Up..."; exit 1; }
195 79224631 Lance Albertson
    done
196 79224631 Lance Albertson
  fi
197 31f11819 Nikos Skalkotos
  echo "Clean UP executed"
198 79224631 Lance Albertson
}
199 79224631 Lance Albertson
200 79224631 Lance Albertson
trap cleanup EXIT
201 79224631 Lance Albertson
202 9cdb305c Lance Albertson
DEFAULT_FILE="@DEFAULT_DIR@/ganeti-instance-image"
203 79224631 Lance Albertson
if [ -f "$DEFAULT_FILE" ]; then
204 79224631 Lance Albertson
    . "$DEFAULT_FILE"
205 79224631 Lance Albertson
fi
206 79224631 Lance Albertson
207 79224631 Lance Albertson
# note: we don't set a default mirror since debian and ubuntu have
208 79224631 Lance Albertson
# different defaults, and it's better to use the default
209 79224631 Lance Albertson
210 79224631 Lance Albertson
# only if the user want to specify a mirror in the defaults file we
211 79224631 Lance Albertson
# will use it, this declaration is to make sure the variable is set
212 828670a1 Lance Albertson
: ${CDINSTALL:="no"}
213 6738cd80 Nikos Skalkotos
: ${BOOT:="no"}
214 e21b8802 Lance Albertson
: ${SWAP:="yes"}
215 fd786991 Lance Albertson
: ${SWAP_SIZE:="${INSTANCE_BE_memory}"}
216 4c96e490 Lance Albertson
: ${FILESYSTEM:="ext3"}
217 be751693 Lance Albertson
: ${KERNEL_ARGS=""}
218 84472880 Lance Albertson
: ${OVERLAY=""}
219 134c11c3 Lance Albertson
: ${IMAGE_NAME:=""}
220 be751693 Lance Albertson
: ${IMAGE_TYPE:="dump"}
221 8727c57d Lance Albertson
: ${NOMOUNT:="no"}
222 79224631 Lance Albertson
: ${ARCH:=""}
223 549118f0 Lance Albertson
: ${CUSTOMIZE_DIR:="@sysconfdir@/ganeti/instance-image/hooks"}
224 f5aa7725 Lance Albertson
: ${VARIANTS_DIR:="@sysconfdir@/ganeti/instance-image/variants"}
225 7193962d Lance Albertson
: ${NETWORKS_DIR:="@sysconfdir@/ganeti/instance-image/networks"}
226 84472880 Lance Albertson
: ${OVERLAYS_DIR:="@sysconfdir@/ganeti/instance-image/overlays"}
227 2e0988ec Lance Albertson
: ${IMAGE_DIR:="@localstatedir@/cache/ganeti-instance-image"}
228 9014a39d Lance Albertson
: ${IMAGE_DEBUG:="no"}
229 ab462591 Constantinos Venetsanopoulos
: ${TOOLS_DIR:="@OS_DIR@/@OS_NAME@/tools"}
230 f7959feb Lance Albertson
231 79224631 Lance Albertson
SCRIPT_NAME=$(basename $0)
232 77449e7c Lance Albertson
KERNEL_PATH="$INSTANCE_HV_kernel_path"
233 79224631 Lance Albertson
234 103d261e Lance Albertson
if [ -f /sbin/blkid -a -x /sbin/blkid ]; then
235 93fa6b1e Lance Albertson
    VOL_ID="/sbin/blkid -c /dev/null -o value -s UUID"
236 93fa6b1e Lance Albertson
    VOL_TYPE="/sbin/blkid -c /dev/null -o value -s TYPE"
237 103d261e Lance Albertson
else
238 103d261e Lance Albertson
    for dir in /lib/udev /sbin; do
239 103d261e Lance Albertson
        if [ -f $dir/vol_id -a -x $dir/vol_id ]; then
240 103d261e Lance Albertson
            VOL_ID="$dir/vol_id -u"
241 103d261e Lance Albertson
            VOL_TYPE="$dir/vol_id -t"
242 103d261e Lance Albertson
        fi
243 103d261e Lance Albertson
    done
244 103d261e Lance Albertson
fi
245 103d261e Lance Albertson
246 103d261e Lance Albertson
if [ -z "$VOL_ID" ]; then
247 103d261e Lance Albertson
    log_error "vol_id or blkid not found, please install udev or util-linux"
248 103d261e Lance Albertson
    exit 1
249 103d261e Lance Albertson
fi
250 103d261e Lance Albertson
251 103d261e Lance Albertson
252 79224631 Lance Albertson
if [ -z "$OS_API_VERSION" -o "$OS_API_VERSION" = "5" ]; then
253 79224631 Lance Albertson
  OS_API_VERSION=5
254 79224631 Lance Albertson
  GETOPT_RESULT=`getopt -o o:n:i:b:s: -n '$0' -- "$@"`
255 79224631 Lance Albertson
  if [ $? != 0 ] ; then log_error "Terminating..."; exit 1 ; fi
256 79224631 Lance Albertson
  get_api5_arguments $GETOPT_RESULT
257 79224631 Lance Albertson
elif [ "$OS_API_VERSION" = "10" -o "$OS_API_VERSION" = "15" ]; then
258 79224631 Lance Albertson
  get_api10_arguments
259 ab462591 Constantinos Venetsanopoulos
elif [ "$OS_API_VERSION" = "20" ]; then
260 ab462591 Constantinos Venetsanopoulos
  get_api10_arguments
261 ab462591 Constantinos Venetsanopoulos
  get_api20_parameters
262 ab462591 Constantinos Venetsanopoulos
  IMAGE_NAME=$IMG_ID
263 a33d2ab2 Nikos Skalkotos
  IMAGE_TYPE=$IMG_FORMAT
264 79224631 Lance Albertson
else
265 79224631 Lance Albertson
  log_error "Unknown OS API VERSION $OS_API_VERSION"
266 79224631 Lance Albertson
  exit 1
267 79224631 Lance Albertson
fi
268 79224631 Lance Albertson
269 79224631 Lance Albertson
if [ -n "$OS_VARIANT" ]; then
270 79224631 Lance Albertson
  if [ ! -d "$VARIANTS_DIR" ]; then
271 79224631 Lance Albertson
    log_error "OS Variants directory $VARIANTS_DIR doesn't exist"
272 79224631 Lance Albertson
    exit 1
273 79224631 Lance Albertson
  fi
274 79224631 Lance Albertson
  VARIANT_CONFIG="$VARIANTS_DIR/$OS_VARIANT.conf"
275 79224631 Lance Albertson
  if [ -f "$VARIANT_CONFIG" ]; then
276 79224631 Lance Albertson
    . "$VARIANT_CONFIG"
277 79224631 Lance Albertson
  else
278 79224631 Lance Albertson
    if grep -qxF "$OS_VARIANT" variants.list; then
279 f5aa7725 Lance Albertson
      log_error "ERROR: instance-image configuration error"
280 79224631 Lance Albertson
      log_error "  Published variant $OS_VARIANT is missing its config file"
281 79224631 Lance Albertson
      log_error "  Please create $VARIANT_CONFIG or unpublish the variant"
282 79224631 Lance Albertson
      log_error "  (by removing $OS_VARIANT from variants.list)"
283 79224631 Lance Albertson
    else
284 79224631 Lance Albertson
      log_error "Unofficial variant $OS_VARIANT is unsupported"
285 79224631 Lance Albertson
      log_error "Most probably this is a user error, forcing a wrong name"
286 79224631 Lance Albertson
      log_error "To support this variant please create file $VARIANT_CONFIG"
287 79224631 Lance Albertson
    fi
288 79224631 Lance Albertson
    exit 1
289 79224631 Lance Albertson
  fi
290 79224631 Lance Albertson
fi